Index: /trunk/docs/doxyfile
===================================================================
--- /trunk/docs/doxyfile	(revision 150)
+++ /trunk/docs/doxyfile	(revision 151)
@@ -39,5 +39,5 @@
 # a quick idea about the purpose of the project. Keep the description short.
 
-PROJECT_BRIEF          = CFLibrary
+PROJECT_BRIEF          = "CFLibrary (Cheese Foundation Library)"
 
 # With the PROJECT_LOGO tag one can specify an logo or icon that is 
@@ -53,5 +53,5 @@
 # where doxygen was started. If left blank the current directory will be used.
 
-OUTPUT_DIRECTORY       = ../documentation
+OUTPUT_DIRECTORY       = ../Documentation
 
 # If the CREATE_SUBDIRS tag is set to YES, then doxygen will create 
Index: /trunk/include/cf_base.h
===================================================================
--- /trunk/include/cf_base.h	(revision 150)
+++ /trunk/include/cf_base.h	(revision 151)
@@ -10,6 +10,6 @@
  * \mainpage
 
-<h2 style="line-height: 10%;">Welcome to documentation page of libCF</h2>
-&nbsp; - CFLibrary (cheese's foundation library)
+<h2 style="line-height: 10%;">Welcome to documentation for libcf</h2>
+&nbsp; :: CFLibrary (Cheese Foundation Library)
 
 &nbsp; This documentation (suggested by nvdark) includes only manual of APIs.
@@ -40,4 +40,7 @@
 } CF_BOOL;
 
+/** 공용 건텍스트 */
+typedef void *	cf_ctx;
+
 /** 성공 시, 반환 값 */
 #define CF_OK							0
Index: /trunk/include/cf_error.h
===================================================================
--- /trunk/include/cf_error.h	(revision 150)
+++ /trunk/include/cf_error.h	(revision 151)
@@ -21,8 +21,10 @@
 #define CF_ERROR_FILE_READ					CF_ERROR_FILE - 3
 #define CF_ERROR_FILE_WRITE					CF_ERROR_FILE - 4
-#define CF_ERROR_FILE_CREATE				CF_ERROR_FILE - 5
+#define CF_ERROR_FILE_CREATE_CTX			CF_ERROR_FILE - 5
 #define CF_ERROR_FILE_CLOSE					CF_ERROR_FILE - 6
 #define CF_ERROR_FILE_GET_SIZE				CF_ERROR_FILE - 7
 #define CF_ERROR_FILE_MAKE_DIRECTORY		CF_ERROR_FILE - 8
+#define CF_ERROR_FILE_ALLOCATE_BUFFER		CF_ERROR_FILE - 9
+#define CF_ERROR_FILE_INVALID_CTX			CF_ERROR_FILE - 10
 /* }}} file */
 
@@ -47,5 +49,7 @@
 #define CF_ERROR_SOCKET_SEND				CF_ERROR_SOCKET - 16
 #define CF_ERROR_SOCKET_RECV				CF_ERROR_SOCKET - 17
-#define CF_ERROR_SOCKET_INTERNAL			CF_ERROR_SOCKET - 18
+#define CF_ERROR_SOCKET_CHECK_DESC_SET		CF_ERROR_SOCKET - 18
+#define CF_ERROR_SOCKET_INVALID_CTX			CF_ERROR_SOCKET - 19
+#define CF_ERROR_SOCKET_CREATE_CTX			CF_ERROR_SOCKET - 20
 /* }}} socket */
 
@@ -85,19 +89,12 @@
 #define CF_ERROR_LOG						CF_ERROR_BASE * 6
 /*------------------------------------------------------------*/
-#define CF_ERROR_LOG_INITIALIZE				CF_ERROR_LOG - 1
-#define CF_ERROR_LOG_INVALID_CTX			CF_ERROR_LOG - 2
-#define CF_ERROR_LOG_SET_MULTITHREAD		CF_ERROR_LOG - 3
-#define CF_ERROR_LOG_UNSET_MULTITHREAD		CF_ERROR_LOG - 4
-#define CF_ERROR_LOG_LOCK_CTX				CF_ERROR_LOG - 5
-#define CF_ERROR_LOG_UNLOCK_CTX				CF_ERROR_LOG - 6
-#define CF_ERROR_LOG_FLUSH					CF_ERROR_LOG - 7
-#define CF_ERROR_LOG_INVALID_MAPID			CF_ERROR_LOG - 8
-#define CF_ERROR_LOG_NOT_MAPPED_ID			CF_ERROR_LOG - 9
-#define CF_ERROR_LOG_ALREADY_MAPPED_ID		CF_ERROR_LOG - 10
-#define CF_ERROR_LOG_NOT_INITIALIZE			CF_ERROR_LOG - 11
-#define CF_ERROR_LOG_INVALID_ARGS			CF_ERROR_LOG - 12
-#define CF_ERROR_LOG_CREATE_CTX				CF_ERROR_LOG - 13
-#define CF_ERROR_LOG_CREATE_FILE			CF_ERROR_LOG - 14
-#define CF_ERROR_LOG_ALLOCATE_BUFFER		CF_ERROR_LOG - 15
+#define CF_ERROR_LOG_INVALID_CTX			CF_ERROR_LOG - 1
+#define CF_ERROR_LOG_SET_MULTITHREAD		CF_ERROR_LOG - 2
+#define CF_ERROR_LOG_UNSET_MULTITHREAD		CF_ERROR_LOG - 3
+#define CF_ERROR_LOG_FLUSH					CF_ERROR_LOG - 4
+#define CF_ERROR_LOG_INVALID_ARGS			CF_ERROR_LOG - 5
+#define CF_ERROR_LOG_CREATE_CTX				CF_ERROR_LOG - 6
+#define CF_ERROR_LOG_CREATE_FILE			CF_ERROR_LOG - 7
+#define CF_ERROR_LOG_ALLOCATE_BUFFER		CF_ERROR_LOG - 8
 /* }}} log */
 
@@ -128,3 +125,25 @@
 /* }}} bitwise */
 
+/* util {{{ */
+#define CF_ERROR_UTIL						CF_ERROR_BASE * 10
+/*------------------------------------------------------------*/
+#define CF_ERROR_UTIL_INVALID_ARGS			CF_ERROR_UTIL - 1
+/* }}} util */
+
+/* context-manager {{{ */
+#define CF_ERROR_CTXMGR						CF_ERROR_BASE * 11
+/*------------------------------------------------------------*/
+#define CF_ERROR_CTXMGR_INITIALIZE			CF_ERROR_CTXMGR - 1
+#define CF_ERROR_CTXMGR_FINALIZE			CF_ERROR_CTXMGR - 2
+#define CF_ERROR_CTXMGR_REGISTER			CF_ERROR_CTXMGR - 3
+#define CF_ERROR_CTXMGR_UNREGISTER			CF_ERROR_CTXMGR - 4
+#define CF_ERROR_CTXMGR_FIND_FIRST_CTX		CF_ERROR_CTXMGR - 5
+#define CF_ERROR_CTXMGR_FIND_CTX			CF_ERROR_CTXMGR - 6
+#define CF_ERROR_CTXMGR_CHECK_DUPLICATION	CF_ERROR_CTXMGR - 7
+#define CF_ERROR_CTXMGR_ALREADY_REGISTERED	CF_ERROR_CTXMGR - 8
+#define CF_ERROR_CTXMGR_NOT_REGISTERED		CF_ERROR_CTXMGR - 9
+#define CF_ERROR_CTXMGR_CREATE_POOL			CF_ERROR_CTXMGR - 10
+#define CF_ERROR_CTXMGR_GET					CF_ERROR_CTXMGR - 11
+/* }}} context-manager */
+
 #endif // #ifndef __CF_ERROR_H__
Index: /trunk/include/cf_file.h
===================================================================
--- /trunk/include/cf_file.h	(revision 150)
+++ /trunk/include/cf_file.h	(revision 151)
@@ -31,20 +31,18 @@
 
 CF_EXPORT int
-CF_File_Open			(const char			* path,
+CF_File_Open			(cf_ctx				* ctx,
+						 const char			* path,
 						 const CF_FILE_FLAG	flag);
 
 CF_EXPORT int
-CF_File_Create			(const char * path);
+CF_File_Close			(cf_ctx ctx);
 
 CF_EXPORT int
-CF_File_Close			(const int fd);
-
-CF_EXPORT int
-CF_File_Read			(const int		fd,
+CF_File_Read			(const cf_ctx	ctx,
 						 void			* buf,
 						 const size_t	len);
 
 CF_EXPORT int
-CF_File_Write			(const int		fd,
+CF_File_Write			(const cf_ctx	ctx,
 						 const void		* buf, 
 						 const size_t	len);
@@ -59,4 +57,8 @@
 CF_File_MakeDirectory	(const char * path);
 
+CF_EXPORT int
+CF_File_GetPath			(const cf_ctx	ctx,
+						 char			* path);
+
 #ifdef __cplusplus
 }
Index: /trunk/include/cf_list.h
===================================================================
--- /trunk/include/cf_list.h	(revision 150)
+++ /trunk/include/cf_list.h	(revision 151)
@@ -13,16 +13,6 @@
 #include "cf_base.h"
 
-/** 리스트 컨텍스트 (Opaque) */
-typedef void *	CF_List_Ctx;
-
 /** 리스트 탐색자 (Opaque) */
-typedef void *	CF_Traverser;
-
-/** 추가 위치 */
-typedef enum
-{
-	CF_DIRECTION_BEFORE,	/**< traverser의 앞 */
-	CF_DIRECTION_AFTER		/**< traverser의 뒤 */
-} CF_DIRECTION;
+typedef cf_ctx	cf_traverser;
 
 #ifdef __cplusplus
@@ -31,42 +21,58 @@
 
 CF_EXPORT int
-CF_List_CreateCtx		(CF_List_Ctx * ctx);
+CF_List_Create			(cf_ctx * ctx);
 
 CF_EXPORT int
-CF_List_DestroyCtx		(CF_List_Ctx ctx);
+CF_List_Destroy			(cf_ctx ctx);
 
 CF_EXPORT int
-CF_List_Front			(CF_List_Ctx	ctx,
-						 CF_Traverser	* traverser);
+CF_List_Front			(cf_ctx			ctx,
+						 cf_traverser	* traverser);
 
 CF_EXPORT int
-CF_List_Rear			(CF_List_Ctx	ctx,
-						 CF_Traverser	* traverser);
+CF_List_Rear			(cf_ctx			ctx,
+						 cf_traverser	* traverser);
 
 CF_EXPORT int
-CF_List_Insert			(CF_List_Ctx		ctx,
-						 const CF_Traverser	traverser,
-						 const CF_DIRECTION	direction,
+CF_List_AddFront		(cf_ctx		ctx,
+						 const void	* element);
+
+CF_EXPORT int
+CF_List_AddRear			(cf_ctx		ctx,
+						 const void	* element);
+
+CF_EXPORT int
+CF_List_InsertBefore	(cf_ctx				ctx,
+						 const cf_traverser	traverser,
 						 const void			* element);
 
 CF_EXPORT int
-CF_List_Remove			(CF_List_Ctx	ctx,
-						 CF_Traverser	* traverser);
+CF_List_InsertAfter		(cf_ctx				ctx,
+						 const cf_traverser	traverser,
+						 const void			* element);
 
 CF_EXPORT int
-CF_List_RemoveAll		(CF_List_Ctx ctx);
+CF_List_Set				(cf_traverser	traverser,
+						 const void		* element);
 
 CF_EXPORT int
-CF_List_GetElement		(const CF_Traverser	traverser,
+CF_List_Get				(const cf_traverser	traverser,
 						 void				** element);
 
 CF_EXPORT int
-CF_List_Prev			(CF_Traverser * traverser);
+CF_List_Remove			(cf_ctx			ctx,
+						 cf_traverser	* traverser);
 
 CF_EXPORT int
-CF_List_Next			(CF_Traverser * traverser);
+CF_List_RemoveAll		(cf_ctx ctx);
 
 CF_EXPORT int
-CF_List_GetSize			(CF_List_Ctx ctx);
+CF_List_Prev			(cf_traverser * traverser);
+
+CF_EXPORT int
+CF_List_Next			(cf_traverser * traverser);
+
+CF_EXPORT int
+CF_List_GetSize			(cf_ctx ctx);
 
 #ifdef __cplusplus
Index: /trunk/include/cf_log.h
===================================================================
--- /trunk/include/cf_log.h	(revision 150)
+++ /trunk/include/cf_log.h	(revision 151)
@@ -29,28 +29,24 @@
 
 CF_EXPORT int
-CF_Log_Initialize		(const int poolSize);
-
-CF_EXPORT int
-CF_Log_Finalize			(void);
-
-CF_EXPORT int
-CF_Log_Open				(const int	mapid,
+CF_Log_Create			(cf_ctx		* ctx,
 						 const char	* path,
 						 const int	memsize);
 
 CF_EXPORT int
-CF_Log_Close			(const int mapid);
+CF_Log_Destroy			(cf_ctx ctx);
 
 CF_EXPORT int
-CF_Log_Write			(const int	mapid,
+CF_Log_Write			(cf_ctx		ctx,
 						 const char	* prefix,
 						 const char	* fmt, ...);
 
 CF_EXPORT int
-CF_Log_Flush			(const int mapid);
+CF_Log_Flush			(cf_ctx ctx);
 
 CF_EXPORT int
-CF_Log_SetMT			(const int		mapid,
-						 const CF_BOOL	flag);
+CF_Log_SetMultiThread	(cf_ctx ctx);
+
+CF_EXPORT int
+CF_Log_UnsetMultiThread	(cf_ctx ctx);
 
 #ifdef __cplusplus
Index: /trunk/include/cf_mutex.h
===================================================================
--- /trunk/include/cf_mutex.h	(revision 150)
+++ /trunk/include/cf_mutex.h	(revision 151)
@@ -5,6 +5,4 @@
  *
  * \brief 뮤텍스 지원
- *
- * \example thread.c
  */
 #ifndef __CF_MUTEX_H__
@@ -13,7 +11,4 @@
 #include "cf_base.h"
 
-/** 뮤텍스 컨텍스트 */
-typedef void *	CF_Mutex_Ctx;
-
 #ifdef __cplusplus
 extern "C" {
@@ -21,14 +16,14 @@
 
 CF_EXPORT int
-CF_Mutex_CreateCtx		(CF_Mutex_Ctx * ctx);
+CF_Mutex_Create			(cf_ctx * ctx);
 
 CF_EXPORT int
-CF_Mutex_DestoryCtx		(CF_Mutex_Ctx ctx);
+CF_Mutex_Destory		(cf_ctx ctx);
 
 CF_EXPORT int
-CF_Mutex_Lock			(CF_Mutex_Ctx ctx);
+CF_Mutex_Lock			(cf_ctx ctx);
 
 CF_EXPORT int
-CF_Mutex_Unlock			(CF_Mutex_Ctx ctx);
+CF_Mutex_Unlock			(cf_ctx ctx);
 
 #ifdef __cplusplus
Index: /trunk/include/cf_queue.h
===================================================================
--- /trunk/include/cf_queue.h	(revision 150)
+++ /trunk/include/cf_queue.h	(revision 151)
@@ -13,7 +13,4 @@
 #include "cf_base.h"
 
-/** 큐 컨텍스트 (Opaque) */
-typedef void *	CF_Queue_Ctx;
-
 #ifdef __cplusplus
 extern "C" {
@@ -21,23 +18,23 @@
 
 CF_EXPORT int
-CF_Queue_CreateCtx		(CF_Queue_Ctx * ctx);
+CF_Queue_Create			(cf_ctx * ctx);
 
 CF_EXPORT int
-CF_Queue_DestroyCtx		(CF_Queue_Ctx ctx);
+CF_Queue_Destroy		(cf_ctx ctx);
 
 CF_EXPORT int
-CF_Queue_Put			(CF_Queue_Ctx	ctx,
-						 const void		* element);
+CF_Queue_Put			(cf_ctx		ctx,
+						 const void	* element);
 
 CF_EXPORT int
-CF_Queue_Get			(CF_Queue_Ctx	ctx,
-						 void			** element);
+CF_Queue_Get			(cf_ctx	ctx,
+						 void	** element);
 
 CF_EXPORT int
-CF_Queue_Front			(CF_Queue_Ctx	ctx,
-						 void			** element);
+CF_Queue_Front			(cf_ctx	ctx,
+						 void	** element);
 
 CF_EXPORT int
-CF_Queue_GetSize		(CF_Queue_Ctx ctx);
+CF_Queue_GetSize		(cf_ctx ctx);
 
 #ifdef __cplusplus
Index: /trunk/include/cf_socket.h
===================================================================
--- /trunk/include/cf_socket.h	(revision 150)
+++ /trunk/include/cf_socket.h	(revision 151)
@@ -16,12 +16,9 @@
 
 /** 타임아웃을 설정하지 않음 */
-#define CF_SOCKET_NO_TIMEOUT		-1
+#define CF_SOCKET_NO_TIMEOUT		0
 
 #ifdef __cplusplus
 extern "C" {
 #endif
-
-CF_EXPORT CF_BOOL
-CF_Socket_IsInitialized		(void);
 
 CF_EXPORT int
@@ -32,8 +29,35 @@
 
 CF_EXPORT int
-CF_Socket_Close				(const int sock);
+CF_Socket_Create			(cf_ctx * ctx);
 
 CF_EXPORT int
-CF_Socket_SetOption			(const int		sock,
+CF_Socket_Close				(cf_ctx ctx);
+
+CF_EXPORT int
+CF_Socket_Connect			(cf_ctx					ctx,
+							 const char				* ip,
+							 const unsigned short	port);
+
+CF_EXPORT int
+CF_Socket_Server			(cf_ctx					ctx,
+							 const unsigned short	port,
+							 const int				backlog);
+
+CF_EXPORT int
+CF_Socket_Accept			(const cf_ctx	ctx,
+							 cf_ctx			* client);
+
+CF_EXPORT int
+CF_Socket_Send				(const cf_ctx	ctx,
+							 const void		* buf,
+							 const size_t	len);
+
+CF_EXPORT int
+CF_Socket_Recv				(const cf_ctx	ctx,
+							 void			* buf,
+							 const size_t	len);
+
+CF_EXPORT int
+CF_Socket_SetOption			(const cf_ctx	ctx,
 							 const int		optname,
 							 const void		* optval,
@@ -41,46 +65,20 @@
 
 CF_EXPORT int
-CF_Socket_GetOption			(const int	sock,
-							 const int	optname,
-							 void		* optval,
-							 size_t		* optlen);
+CF_Socket_GetOption			(const cf_ctx	ctx,
+							 const int		optname,
+							 void			* optval,
+							 size_t			* optlen);
 
 CF_EXPORT int
-CF_Socket_Connect			(const char				* ip,
-							 const unsigned short	port);
+CF_Socket_SetTimeOut		(cf_ctx	ctx,
+							 int	timeout);
 
 CF_EXPORT int
-CF_Socket_ConnectTimeout	(const char				* ip,
-							 const unsigned short	port,
-							 const int				timeout);
+CF_Socket_GetIP				(const cf_ctx	ctx,
+							 char			* ip);
 
 CF_EXPORT int
-CF_Socket_Server			(const unsigned short	port,
-							 const int				backlog);
-
-CF_EXPORT int
-CF_Socket_Accept			(const int sock);
-
-CF_EXPORT int
-CF_Socket_Send				(const int		sock,
-							 const void		* buf,
-							 const size_t	len);
-
-CF_EXPORT int
-CF_Socket_SendTimeout		(const int		sock,
-							 const void		* buf,
-							 const size_t	len,
-							 const int		timeout);
-
-CF_EXPORT int
-CF_Socket_Recv				(const int		sock,
-							 void			* buf,
-							 const size_t	len);
-
-CF_EXPORT int
-CF_Socket_RecvTimeout		(const int		sock,
-							 void			* buf,
-							 const size_t	len,
-							 const int		timeout);
+CF_Socket_GetPort			(const cf_ctx	ctx,
+							 unsigned short	* port);
 
 #ifdef __cplusplus
Index: /trunk/include/cf_stack.h
===================================================================
--- /trunk/include/cf_stack.h	(revision 150)
+++ /trunk/include/cf_stack.h	(revision 151)
@@ -13,7 +13,4 @@
 #include "cf_base.h"
 
-/** 스택 컨텍스트 (Opaque) */
-typedef void *	CF_Stack_Ctx;
-
 #ifdef __cplusplus
 extern "C" {
@@ -21,23 +18,23 @@
 
 CF_EXPORT int
-CF_Stack_CreateCtx		(CF_Stack_Ctx * ctx);
+CF_Stack_Create			(cf_ctx * ctx);
 
 CF_EXPORT int
-CF_Stack_DestroyCtx		(CF_Stack_Ctx ctx);
+CF_Stack_Destroy		(cf_ctx ctx);
 
 CF_EXPORT int
-CF_Stack_Push			(CF_Stack_Ctx	ctx,
-						 const void		* element);
+CF_Stack_Push			(cf_ctx		ctx,
+						 const void	* element);
 
 CF_EXPORT int
-CF_Stack_Pop			(CF_Stack_Ctx	ctx,
-						 void			** element);
+CF_Stack_Pop			(cf_ctx	ctx,
+						 void	** element);
 
 CF_EXPORT int
-CF_Stack_Top			(CF_Stack_Ctx 	ctx,
-						 void			** element);
+CF_Stack_Top			(cf_ctx	ctx,
+						 void	** element);
 
 CF_EXPORT int
-CF_Stack_GetSize		(CF_Stack_Ctx ctx);
+CF_Stack_GetSize		(cf_ctx ctx);
 
 #ifdef __cplusplus
Index: /trunk/include/cf_thread.h
===================================================================
--- /trunk/include/cf_thread.h	(revision 150)
+++ /trunk/include/cf_thread.h	(revision 151)
@@ -16,7 +16,4 @@
 typedef int (* CF_Thread_Function) (void *);
 
-/** 스레드 컨텍스트 */
-typedef void *	CF_Thread_Ctx;
-
 #ifdef __cplusplus
 extern "C" {
@@ -24,16 +21,16 @@
 
 CF_EXPORT int
-CF_Thread_CreateCtx		(CF_Thread_Ctx		* ctx,
+CF_Thread_Create		(cf_ctx				* ctx,
 						 CF_Thread_Function	callback,
 						 void				* arg);
 
 CF_EXPORT int
-CF_Thread_Start			(CF_Thread_Ctx ctx);
+CF_Thread_Start			(cf_ctx ctx);
 
 CF_EXPORT int
-CF_Thread_DestroyCtx	(CF_Thread_Ctx ctx);
+CF_Thread_Destroy		(cf_ctx ctx);
 
 CF_EXPORT int
-CF_Thread_Join			(CF_Thread_Ctx ctx);
+CF_Thread_Join			(cf_ctx ctx);
 
 #ifdef __cplusplus
Index: /trunk/include/cf_util.h
===================================================================
--- /trunk/include/cf_util.h	(revision 151)
+++ /trunk/include/cf_util.h	(revision 151)
@@ -0,0 +1,48 @@
+/**
+ * \file cf_util.h
+ *
+ * \author myusgun <myusgun@gmail.com>
+ *
+ * \brief 유틸
+ *
+ * \example util.c
+ */
+#ifndef __CF_UTIL_H__
+#define __CF_UTIL_H__
+
+#include "cf_base.h"
+
+#define CF_UTIL_DATETIME_LENGTH	(sizeof ("0000-00-00 00:00:00.000") - 1)
+
+typedef struct __cf_util_datetime__
+{
+	int year;
+	int month;
+	int day;
+	int week; /* SUN:0 ~ SAT:6 */
+
+	int hour;
+	int min;
+	int sec;
+	int usec;
+} CF_UTIL_DATETIME;
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+CF_EXPORT int
+CF_Util_GetSystemError		(void);
+
+CF_EXPORT int
+CF_Util_GetCurrentTime		(CF_UTIL_DATETIME * dt);
+
+CF_EXPORT int
+CF_Util_GetTimeString		(const CF_UTIL_DATETIME	* dt,
+							 char					* buffer);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif // #ifndef __CF_UTIL_H__
Index: /trunk/makeinclude/platform.mk
===================================================================
--- /trunk/makeinclude/platform.mk	(revision 150)
+++ /trunk/makeinclude/platform.mk	(revision 151)
@@ -9,5 +9,5 @@
 DOXYGEN	:= $(shell which doxygen)
 
-DOXYGEN_OUTPUT_PATH	= ../documentation
+DOXYGEN_OUTPUT_PATH	= ../Documentation
 DOXYGEN_PATH		= ../docs
 DOXYGEN_FILE		= $(DOXYGEN_PATH)/doxyfile
@@ -16,5 +16,5 @@
 # set options
 #------------------------------------------------------------
-ifeq ($(DEBUG), YES)
+ifeq ($(DEBUG), yes)
 	DEFS = -D_DEBUG
 	FLAG = -g
Index: /trunk/makeinclude/userdefine.mk
===================================================================
--- /trunk/makeinclude/userdefine.mk	(revision 150)
+++ /trunk/makeinclude/userdefine.mk	(revision 151)
@@ -9,7 +9,7 @@
 # compile with debugging flag and definition
 # > YES or NO
-DEBUG			= YES
+DEBUG			= yes
 
 # create doxygen documents automatically
 # > YES or NO
-DOXYGEN_CREATE	= YES
+DOXYGEN_CREATE	= yes
Index: /trunk/src/cf_codec.c
===================================================================
--- /trunk/src/cf_codec.c	(revision 150)
+++ /trunk/src/cf_codec.c	(revision 151)
@@ -13,62 +13,10 @@
 #include <stdio.h>
 
+#define BASE64_PADDING_CHAR_INDEX	64
+
 #define ASSERT_ARGS(x)	\
 	if ((x))			\
 		return CF_ERROR_CODEC_INVALID_ARGS
 
-const static cf_byte g_ascii_HexDecode[] = {
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  00 -  15 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  16 -  31 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  32 -  47 */
-	 '0', '0', '0', '0', '0', '0', '0', '0', '0', '0',0x00,0x00,0x00,0x00,0x00,0x00,	/*  48 -  63 */
-	0x00, 'A', 'A', 'A', 'A', 'A', 'A',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  64 -  79 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  80 -  95 */
-	0x00, 'a', 'a', 'a', 'a', 'a', 'a',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  96 - 111 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 112 - 127 */
-	/* end of ascii character */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 128 - 143 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 144 - 159 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 160 - 175 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 176 - 191 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 192 - 207 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 208 - 223 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 224 - 239 */
-	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 240 - 255 */
-};
-
-const static char g_table_Base64Encode[] = {
-#define BASE64_PADDING_CHAR_INDEX	64
-	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',		/* 00 - 07 */
-	'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',		/* 08 - 15 */
-	'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',		/* 16 - 23 */
-	'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',		/* 24 - 31 */
-	'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',		/* 32 - 39 */
-	'o', 'p', 'q', 'r', 's', 't', 'u', 'v',		/* 40 - 47 */
-	'w', 'x', 'y', 'z', '0', '1', '2', '3',		/* 48 - 55 */
-	'4', '5', '6', '7', '8', '9', '+', '/',		/* 56 - 63 */
-	'='											/* padding */
-};
-
-const static cf_byte g_ascii_Base64Decode[] = {
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/*  00 -  15 */
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/*  16 -  31 */
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,  62,0xff,0xff,0xff,  63,	/*  32 -  47 */
-	  52,  53,  54,  55,  56,  57,  58,  59,  60,  61,0xff,0xff,0xff,  64,0xff,0xff,	/*  48 -  63 */
-	0xff,   0,   1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14,	/*  64 -  79 */
-	  15,  16,  17,  18,  19,  20,  21,  22,  23,  24,  25,0xff,0xff,0xff,0xff,0xff,	/*  80 -  95 */
-	0xff,  26,  27,  28,  29,  30,  31,  32,  33,  34,  35,  36,  37,  38,  39,  40,	/*  96 - 111 */
-	  41,  42,  43,  44,  45,  46,  47,  48,  49,  50,  51,0xff,0xff,0xff,0xff,0xff,	/* 112 - 127 */
-	/* end of ascii character */
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 128 - 143 */
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 144 - 159 */
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 160 - 175 */
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 176 - 191 */
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 192 - 207 */
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 208 - 223 */
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 224 - 239 */
-	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 240 - 255 */
-};
-
-
 /**
  * hex-encode
@@ -88,23 +36,21 @@
 					 char			* hex)
 {
-	size_t	iter = 0;
-	size_t	hexlen = len * 2 + 1;
-
-	const cf_byte	* ptr = bin;
-
-	const static char	hexchar[] = {'0', '1', '2', '3',
-									 '4', '5', '6', '7',
-									 '8', '9', 'a', 'b',
-									 'c', 'd', 'e', 'f'};
+	const cf_byte	* src = bin;
+	char			* dst = hex;
+
+	const static char	hexenc[] = {
+		'0', '1', '2', '3', '4', '5', '6', '7',
+		'8', '9', 'a', 'b', 'c', 'd', 'e', 'f'
+	};
 
 	ASSERT_ARGS (bin == NULL);
 	ASSERT_ARGS (hex == NULL);
 
-	for (iter = 0 ; iter < hexlen ; iter += 2, ptr++)
-	{
-		hex[iter    ] = hexchar[((*(ptr)) >> 4) & 0x0f];
-		hex[iter + 1] = hexchar[((*(ptr))     ) & 0x0f];
-	}
-	hex[hexlen - 1] = '\0';
+	for ( ; *src ; src++)
+	{
+		*dst++ = hexenc[((*src) >> 4) & 0x0f];
+		*dst++ = hexenc[((*src)     ) & 0x0f];
+	}
+	*dst = '\0';
 
 	return CF_OK;
@@ -114,5 +60,5 @@
  * hex-decode
  *
- * \return 성공 시, 디코딩된 바이너리 데이터의 길이; 실패 시, 오류 코드
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
  *
  * \param hex	16진수 문자열
@@ -129,48 +75,61 @@
 {
 	size_t		length = 0;	/* absolutely even-number */
-	size_t		iter = 0;
-	size_t		binlen = 0;
-
-	const char	* ptr = hex;
+
+	const char	* src = hex;
+	cf_byte		* dst = bin;
 	char		buf = 0;
 	cf_byte		val = 0;
 	cf_byte		asciiHex = 0;
 
+	const static cf_byte hexdec[] = {
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  00 -  07 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  08 -  15 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  16 -  23 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  24 -  31 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  32 -  39 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  40 -  47 */
+		 '0', '0', '0', '0', '0', '0', '0', '0',	/*  48 -  55 */
+		 '0', '0',0x00,0x00,0x00,0x00,0x00,0x00,	/*  56 -  63 */
+		0x00, 'A', 'A', 'A', 'A', 'A', 'A',0x00,	/*  64 -  71 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  71 -  79 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  80 -  87 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  88 -  95 */
+		0x00, 'a', 'a', 'a', 'a', 'a', 'a',0x00,	/*  96 - 103 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 104 - 111 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 112 - 119 */
+		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00		/* 120 - 127 */
+	};
+
 	ASSERT_ARGS (hex == NULL);
 	ASSERT_ARGS (bin == NULL);
 	ASSERT_ARGS (len == NULL);
 
-	*len = 0;
-
-	for ( ; g_ascii_HexDecode[(int)*ptr] && *ptr ; ptr++, length++);
-
-	if (*ptr)
+	for ( ; hexdec[(int)*src] && *src ; src++, length++);
+
+	if (*src)
 		return CF_ERROR_CODEC_NOT_HEXSTRING;
 
-	binlen = length / 2;
-
-	for (iter = 0, ptr = hex ; *ptr ; iter++)
+	for (src = hex ; *src ; )
 	{
 		val = 0;	/* init/re-init docoding-buffer */
 
 		/* decode one character */
-#define DECODE_HEX(x)								\
-		do {										\
-		buf = *(x);									\
-		val = (cf_byte)(val << 4);			\
-		asciiHex = g_ascii_HexDecode[(int)buf];		\
-													\
-		val |=	(cf_byte)						\
+#define DECODE_HEX(x)					\
+		do {							\
+		buf = *(x);						\
+		val = (cf_byte)(val << 4);		\
+		asciiHex = hexdec[(int)buf];	\
+		\
+		val |=	(cf_byte)				\
 				(buf - asciiHex + (asciiHex == '0' ? 0 : 10));	\
 		} while (0)
 
 		/* decode one byte by decode two character */
-		DECODE_HEX (ptr++);
-		DECODE_HEX (ptr++);
-
-		bin[iter] = val;
-	}
-
-	* len = binlen;
+		DECODE_HEX (src++);
+		DECODE_HEX (src++);
+
+		*dst++ = val;
+	}
+	*len = length / 2;
 
 	return CF_OK;
@@ -196,4 +155,16 @@
 	const cf_byte	* src = bin;
 	char			* dst = base64;
+
+	const static char base64enc[] = {
+		'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',	/* 00 - 07 */
+		'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',	/* 08 - 15 */
+		'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',	/* 16 - 23 */
+		'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',	/* 24 - 31 */
+		'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',	/* 32 - 39 */
+		'o', 'p', 'q', 'r', 's', 't', 'u', 'v',	/* 40 - 47 */
+		'w', 'x', 'y', 'z', '0', '1', '2', '3',	/* 48 - 55 */
+		'4', '5', '6', '7', '8', '9', '+', '/',	/* 56 - 63 */
+		'='										/* padding */
+	};
 
 	ASSERT_ARGS (src == NULL);
@@ -207,31 +178,28 @@
 #define SEXTUPLE_E_6(__x)	(((__x[2])     ) & 0x3f)
 
-	for ( ; src - bin < len - 2 ; src += 3)
-	{
-		*dst++ = g_table_Base64Encode[SEXTUPLE_E_1 (src)];
-		*dst++ = g_table_Base64Encode[SEXTUPLE_E_2 (src)|
-									  SEXTUPLE_E_3 (src)];
-		*dst++ = g_table_Base64Encode[SEXTUPLE_E_4 (src)|
-									  SEXTUPLE_E_5 (src)];
-		*dst++ = g_table_Base64Encode[SEXTUPLE_E_6 (src)];
-	}
-
-	if (src - bin < len)
-	{
-		*dst++ = g_table_Base64Encode[SEXTUPLE_E_1 (src)];
+	for ( ; (size_t)(src - bin) < len - 2 ; src += 3)
+	{
+		*dst++ = base64enc[SEXTUPLE_E_1 (src)];
+		*dst++ = base64enc[SEXTUPLE_E_2 (src) | SEXTUPLE_E_3 (src)];
+		*dst++ = base64enc[SEXTUPLE_E_4 (src) | SEXTUPLE_E_5 (src)];
+		*dst++ = base64enc[SEXTUPLE_E_6 (src)];
+	}
+
+	if ((size_t)(src - bin) < len)
+	{
+		*dst++ = base64enc[SEXTUPLE_E_1 (src)];
 
 		if (src - bin == len - 1)
 		{
-			*dst++ = g_table_Base64Encode[SEXTUPLE_E_2 (src)];
-			*dst++ = g_table_Base64Encode[BASE64_PADDING_CHAR_INDEX];
+			*dst++ = base64enc[SEXTUPLE_E_2 (src)];
+			*dst++ = base64enc[BASE64_PADDING_CHAR_INDEX];
 		}
 		else
 		{
-			*dst++ = g_table_Base64Encode[SEXTUPLE_E_2 (src)|
-										  SEXTUPLE_E_3 (src)];
-			*dst++ = g_table_Base64Encode[SEXTUPLE_E_4 (src)];
+			*dst++ = base64enc[SEXTUPLE_E_2 (src) | SEXTUPLE_E_3 (src)];
+			*dst++ = base64enc[SEXTUPLE_E_4 (src)];
 		}
 
-		*dst++ = g_table_Base64Encode[BASE64_PADDING_CHAR_INDEX];
+		*dst++ = base64enc[BASE64_PADDING_CHAR_INDEX];
 	}
 	*dst = '\0';
@@ -243,5 +211,5 @@
  * Base64-decode
  *
- * \return 성공 시, 디코딩된 바이너리 데이터의 길이; 실패 시, 오류 코드
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
  *
  * \param base64	base64 문자열
@@ -259,6 +227,25 @@
 	const char	* src = base64;
 	cf_byte		* dst = bin;
-	int			remain = 0;
-	int			binlen = 0;
+	size_t		remain = 0;
+	size_t		binlen = 0;
+
+	const static cf_byte base64dec[] = {
+		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/*  00 -  07 */
+		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/*  08 -  15 */
+		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/*  16 -  23 */
+		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/*  24 -  31 */
+		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/*  32 -  39 */
+		0xff,0xff,0xff,  62,0xff,0xff,0xff,  63,	/*  40 -  47 */
+		  52,  53,  54,  55,  56,  57,  58,  59,	/*  48 -  55 */
+		  60,  61,0xff,0xff,0xff,  64,0xff,0xff,	/*  56 -  63 */
+		0xff,   0,   1,   2,   3,   4,   5,   6,	/*  64 -  71 */
+	 	   7,   8,   9,  10,  11,  12,  13,  14,	/*  71 -  79 */
+		  15,  16,  17,  18,  19,  20,  21,  22,	/*  80 -  87 */
+		  23,  24,  25,0xff,0xff,0xff,0xff,0xff,	/*  88 -  95 */
+		0xff,  26,  27,  28,  29,  30,  31,  32,	/*  96 - 103 */
+	  	  33,  34,  35,  36,  37,  38,  39,  40,	/* 104 - 111 */
+		  41,  42,  43,  44,  45,  46,  47,  48,	/* 112 - 119 */
+		  49,  50,  51,0xff,0xff,0xff,0xff,0xff		/* 120 - 127 */
+	};
 
 	ASSERT_ARGS (src == NULL);
@@ -266,20 +253,18 @@
 	ASSERT_ARGS (len == NULL);
 
-	*len = 0;
-
-	while (g_ascii_Base64Decode[(int)*src] < BASE64_PADDING_CHAR_INDEX) src++;
+	while (base64dec[(int)*src] < BASE64_PADDING_CHAR_INDEX) src++;
 
 	if (*src == 0xff)
 		return CF_ERROR_CODEC_NOT_BASE64;
 
-	remain = (int)(src - base64);
+	remain = (size_t)(src - base64);
 	binlen = ((remain + 2/* max padding length */) / 4) * 3;
 
-#define SEXTUPLE_D_1(src)	(g_ascii_Base64Decode[(int)src[0]] << 2)
-#define SEXTUPLE_D_2(src)	(g_ascii_Base64Decode[(int)src[1]] >> 4)
-#define SEXTUPLE_D_3(src)	(g_ascii_Base64Decode[(int)src[1]] << 4)
-#define SEXTUPLE_D_4(src)	(g_ascii_Base64Decode[(int)src[2]] >> 2)
-#define SEXTUPLE_D_5(src)	(g_ascii_Base64Decode[(int)src[2]] << 6)
-#define SEXTUPLE_D_6(src)	(g_ascii_Base64Decode[(int)src[3]]     )
+#define SEXTUPLE_D_1(src)	(base64dec[(int)src[0]] << 2)
+#define SEXTUPLE_D_2(src)	(base64dec[(int)src[1]] >> 4)
+#define SEXTUPLE_D_3(src)	(base64dec[(int)src[1]] << 4)
+#define SEXTUPLE_D_4(src)	(base64dec[(int)src[2]] >> 2)
+#define SEXTUPLE_D_5(src)	(base64dec[(int)src[2]] << 6)
+#define SEXTUPLE_D_6(src)	(base64dec[(int)src[3]]     )
 
 	for (src = base64 ; remain > 4 ; remain -= 4, src += 4)
@@ -297,4 +282,6 @@
 		*dst++ = (cf_byte)(SEXTUPLE_D_5 (src) | SEXTUPLE_D_6 (src));
 
-	return binlen - (4 - remain);
-}
+	*len = binlen - (4 - remain);
+
+	return CF_OK;
+}
